IndexReader (Lucene 2.4.1 API)
Keywords: org.apache.lucene.index.IndexReader class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.index
Class IndexReader

    java.lang.Object
      org.apache.lucene.index.IndexReader

Direct Known Subclasses:
  FilterIndexReader, InstantiatedIndexReader, MultiReader, ParallelReader

    public abstract class IndexReader

extends Object

IndexReader is an abstract class, providing an interface for accessing an index. Search of an index is done entirely through this abstract interface, so that any subclass which implements it is searchable.

Concrete subclasses of IndexReader are usually constructed with a call to one of the static `open()` methods, e.g. `open(String)`.

For efficiency, in this API documents are often referred to via document numbers, non-negative integers which each name a unique document in the index. These document numbers are ephemeral--they may change as documents are added to and deleted from an index. Clients should thus not rely on a given document having the same number between sessions.

An IndexReader can be opened on a directory for which an IndexWriter is opened already, but it cannot be used to delete documents from the index then.

NOTE: for backwards API compatibility, several methods are not listed as abstract, but have no useful implementations in this base class and instead always throw UnsupportedOperationException. Subclasses are strongly encouraged to override these methods, but in many cases may not need to.

NOTE: as of 2.4, it's possible to open a read-only IndexReader using one of the static open methods that accepts the boolean readOnly parameter. Such a reader has better concurrency as it's not necessary to synchronize on the isDeleted method. Currently the default for readOnly is false, meaning if not specified you will get a read/write IndexReader. But in 3.0 this default will change to true, meaning you must explicitly specify false if you want to make changes with the resulting IndexReader.

Version:
  $Id: IndexReader.java 695510 2008-09-15 15:33:15Z otis $

Nested Class Summary
`static class` | `IndexReader.FieldOption` Constants describing field properties, for example used for `getFieldNames(FieldOption)`.

Field Summary
`protected boolean` | `hasChanges`

Constructor Summary
`protected` | `IndexReader()`
`protected` | `IndexReader(Directory directory)` Deprecated. - use IndexReader()

Method Summary
`protected void` | `acquireWriteLock()` Does nothing by default.
`void` | `close()` Closes files associated with this index.
`protected void` | `commit()` Commit changes resulting from delete, undeleteAll, or setNorm operations If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics).
`void` | `decRef()` Expert: decreases the refCount of this IndexReader instance.
`void` | `deleteDocument(int docNum)` Deletes the document numbered `docNum`.
`int` | `deleteDocuments(Term term)` Deletes all documents that have a given `term` indexed.
`Directory` | `directory()` Returns the directory associated with this index.
`abstract int` | `docFreq(Term t)` Returns the number of documents containing the term `t`.
`protected abstract void` | `doClose()` Implements close.
`protected abstract void` | `doCommit()` Implements commit.
`Document` | `document(int n)` Returns the stored fields of the `n`th `Document` in this index.
`abstract Document` | `document(int n, FieldSelector fieldSelector)` Get the `Document` at the `n`th position.
`protected abstract void` | `doDelete(int docNum)` Implements deletion of the document numbered `docNum`.
`protected abstract void` | `doSetNorm(int doc, String field, byte value)` Implements setNorm in subclass.
`protected abstract void` | `doUndeleteAll()` Implements actual undeleteAll() in subclass.
`protected void` | `ensureOpen()`
`void` | `flush()`
`static long` | `getCurrentVersion(Directory directory)` Reads version number from segments files.
`static long` | `getCurrentVersion(File directory)` Reads version number from segments files.
`static long` | `getCurrentVersion(String directory)` Reads version number from segments files.
`abstract Collection` | `getFieldNames(IndexReader.FieldOption fldOption)` Get a list of unique field names that exist in this index and have the specified field option information.
`IndexCommit` | `getIndexCommit()` Expert: return the IndexCommit that this reader has opened.
`abstract TermFreqVector` | `getTermFreqVector(int docNumber, String field)` Return a term frequency vector for the specified document and field.
`abstract void` | `getTermFreqVector(int docNumber, String field, TermVectorMapper mapper)` Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.
`abstract void` | `getTermFreqVector(int docNumber, TermVectorMapper mapper)` Map all the term vectors for all fields in a Document
`abstract TermFreqVector[]` | `getTermFreqVectors(int docNumber)` Return an array of term frequency vectors for the specified document.
`int` | `getTermInfosIndexDivisor()` For IndexReader implementations that use TermInfosReader to read terms, this returns the current indexDivisor.
`long` | `getVersion()` Version number when this IndexReader was opened.
`abstract boolean` | `hasDeletions()` Returns true if any documents have been deleted
`boolean` | `hasNorms(String field)` Returns true if there are norms stored for this field.
`void` | `incRef()` Expert: increments the refCount of this IndexReader instance.
`static boolean` | `indexExists(Directory directory)` Returns `true` if an index exists at the specified directory.
`static boolean` | `indexExists(File directory)` Returns `true` if an index exists at the specified directory.
`static boolean` | `indexExists(String directory)` Returns `true` if an index exists at the specified directory.
`boolean` | `isCurrent()` Check whether this IndexReader is still using the current (i.e., most recently committed) version of the index.
`abstract boolean` | `isDeleted(int n)` Returns true if document n has been deleted
`static boolean` | `isLocked(Directory directory)` Deprecated. Please use `IndexWriter.isLocked(Directory)` instead
`static boolean` | `isLocked(String directory)` Deprecated. Please use `IndexWriter.isLocked(String)` instead
`boolean` | `isOptimized()` Checks is the index is optimized (if it has a single segment and no deletions).
`static long` | `lastModified(Directory directory2)` Returns the time the index in the named directory was last modified.
`static long` | `lastModified(File fileDirectory)` Returns the time the index in the named directory was last modified.
`static long` | `lastModified(String directory)` Returns the time the index in the named directory was last modified.
`static Collection` | `listCommits(Directory dir)` Returns all commit points that exist in the Directory.
`static void` | `main(String[] args)` Prints the filename and size of each file within a given compound file.
`abstract int` | `maxDoc()` Returns one greater than the largest possible document number.
`abstract byte[]` | `norms(String field)` Returns the byte-encoded normalization factor for the named field of every document.
`abstract void` | `norms(String field, byte[] bytes, int offset)` Reads the byte-encoded normalization factor for the named field of every document.
`int` | `numDeletedDocs()` Returns the number of deleted documents.
`abstract int` | `numDocs()` Returns the number of documents in this index.
`static IndexReader` | `open(Directory directory)` Returns a read/write IndexReader reading the index in the given Directory.
`static IndexReader` | `open(Directory directory, boolean readOnly)` Returns a read/write or read only IndexReader reading the index in the given Directory.
`static IndexReader` | `open(Directory directory, IndexDeletionPolicy deletionPolicy)` Expert: returns a read/write IndexReader reading the index in the given Directory, with a custom `IndexDeletionPolicy`.
`static IndexReader` | `open(Directory directory, IndexDeletionPolicy deletionPolicy, boolean readOnly)` Expert: returns a read/write or read only IndexReader reading the index in the given Directory, with a custom `IndexDeletionPolicy`.
`static IndexReader` | `open(File path)` Returns a read/write IndexReader reading the index in an FSDirectory in the named path.
`static IndexReader` | `open(IndexCommit commit)` Expert: returns a read/write IndexReader reading the index in the given `IndexCommit`.
`static IndexReader` | `open(IndexCommit commit, IndexDeletionPolicy deletionPolicy)` Expert: returns a read/write IndexReader reading the index in the given Directory, using a specific commit and with a custom `IndexDeletionPolicy`.
`static IndexReader` | `open(IndexCommit commit, IndexDeletionPolicy deletionPolicy, boolean readOnly)` Expert: returns a read/write or read only IndexReader reading the index in the given Directory, using a specific commit and with a custom `IndexDeletionPolicy`.
`static IndexReader` | `open(String path)` Returns a read/write IndexReader reading the index in an FSDirectory in the named path.
`IndexReader` | `reopen()` Refreshes an IndexReader if the index has changed since this instance was (re)opened.
`void` | `setNorm(int doc, String field, byte value)` Expert: Resets the normalization factor for the named field of the named document.
`void` | `setNorm(int doc, String field, float value)` Expert: Resets the normalization factor for the named field of the named document.
`void` | `setTermInfosIndexDivisor(int indexDivisor)` For IndexReader implementations that use TermInfosReader to read terms, this sets the indexDivisor to subsample the number of indexed terms loaded into memory.
`abstract TermDocs` | `termDocs()` Returns an unpositioned `TermDocs` enumerator.
`TermDocs` | `termDocs(Term term)` Returns an enumeration of all the documents which contain `term`.
`abstract TermPositions` | `termPositions()` Returns an unpositioned `TermPositions` enumerator.
`TermPositions` | `termPositions(Term term)` Returns an enumeration of all the documents which contain `term`.
`abstract TermEnum` | `terms()` Returns an enumeration of all the terms in the index.
`abstract TermEnum` | `terms(Term t)` Returns an enumeration of all terms starting at a given term.
`void` | `undeleteAll()` Undeletes all documents currently marked as deleted in this index.
`static void` | `unlock(Directory directory)` Deprecated. Please use `IndexWriter.unlock(Directory)` instead

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### hasChanges

    protected boolean hasChanges

Constructor Detail

### IndexReader

    protected IndexReader(Directory directory)

  Deprecated. - use IndexReader()

  Legacy Constructor for backwards compatibility.

  This Constructor should not be used, it exists for backwards compatibility only to support legacy subclasses that did not "own" a specific directory, but needed to specify something to be returned by the directory() method. Future subclasses should delegate to the no arg constructor and implement the directory() method as appropriate.

  Parameters:
    `directory` - Directory to be returned by the directory() method
  See Also:
    `directory()`

### IndexReader

    protected IndexReader()

Method Detail

### incRef

    public void incRef()

  Expert: increments the refCount of this IndexReader instance. RefCounts are used to determine when a reader can be closed safely, i.e. as soon as there are no more references. Be sure to always call a corresponding `decRef()`, in a finally clause; otherwise the reader may never be closed. Note that `close()` simply calls decRef(), which means that the IndexReader will not really be closed until `decRef()` has been called for all outstanding references.

  See Also:
    `decRef()`

### decRef

    public void decRef()
                throws IOException

  Expert: decreases the refCount of this IndexReader instance. If the refCount drops to 0, then pending changes (if any) are committed to the index and this reader is closed.

  Throws:
    `IOException` - in case an IOException occurs in commit() or doClose()
  See Also:
    `incRef()`

### ensureOpen

    protected final void ensureOpen()
                             throws AlreadyClosedException

  Throws:
    `AlreadyClosedException` - if this IndexReader is closed

### open

    public static IndexReader open(String path)
                            throws CorruptIndexException,
                                   IOException

  Returns a read/write IndexReader reading the index in an FSDirectory in the named path. NOTE: starting in 3.0 this will return a readOnly IndexReader.

  Parameters:
    `path` - the path to the index directory
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### open

    public static IndexReader open(File path)
                            throws CorruptIndexException,
                                   IOException

  Returns a read/write IndexReader reading the index in an FSDirectory in the named path. NOTE: starting in 3.0 this will return a readOnly IndexReader.

  Parameters:
    `path` - the path to the index directory
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### open

    public static IndexReader open(Directory directory)
                            throws CorruptIndexException,
                                   IOException

  Returns a read/write IndexReader reading the index in the given Directory. NOTE: starting in 3.0 this will return a readOnly IndexReader.

  Parameters:
    `directory` - the index directory
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### open

    public static IndexReader open(Directory directory,
                                   boolean readOnly)
                            throws CorruptIndexException,
                                   IOException

  Returns a read/write or read only IndexReader reading the index in the given Directory.

  Parameters:
    `directory` - the index directory
    `readOnly` - true if no changes (deletions, norms) will be made with this IndexReader
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### open

    public static IndexReader open(IndexCommit commit)
                            throws CorruptIndexException,
                                   IOException

  Expert: returns a read/write IndexReader reading the index in the given `IndexCommit`. NOTE: starting in 3.0 this will return a readOnly IndexReader.

  Parameters:
    `commit` - the commit point to open
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### open

    public static IndexReader open(Directory directory,
                                   IndexDeletionPolicy deletionPolicy)
                            throws CorruptIndexException,
                                   IOException

  Expert: returns a read/write IndexReader reading the index in the given Directory, with a custom `IndexDeletionPolicy`. NOTE: starting in 3.0 this will return a readOnly IndexReader.

  Parameters:
    `directory` - the index directory
    `deletionPolicy` - a custom deletion policy (only used if you use this reader to perform deletes or to set norms); see `IndexWriter` for details.
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### open

    public static IndexReader open(Directory directory,
                                   IndexDeletionPolicy deletionPolicy,
                                   boolean readOnly)
                            throws CorruptIndexException,
                                   IOException

  Expert: returns a read/write or read only IndexReader reading the index in the given Directory, with a custom `IndexDeletionPolicy`. NOTE: starting in 3.0 this will return a readOnly IndexReader.

  Parameters:
    `directory` - the index directory
    `deletionPolicy` - a custom deletion policy (only used if you use this reader to perform deletes or to set norms); see `IndexWriter` for details.
    `readOnly` - true if no changes (deletions, norms) will be made with this IndexReader
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### open

    public static IndexReader open(IndexCommit commit,
                                   IndexDeletionPolicy deletionPolicy)
                            throws CorruptIndexException,
                                   IOException

  Expert: returns a read/write IndexReader reading the index in the given Directory, using a specific commit and with a custom `IndexDeletionPolicy`. NOTE: starting in 3.0 this will return a readOnly IndexReader.

  Parameters:
    `commit` - the specific `IndexCommit` to open; see `listCommits(org.apache.lucene.store.Directory)` to list all commits in a directory
    `deletionPolicy` - a custom deletion policy (only used if you use this reader to perform deletes or to set norms); see `IndexWriter` for details.
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### open

    public static IndexReader open(IndexCommit commit,
                                   IndexDeletionPolicy deletionPolicy,
                                   boolean readOnly)
                            throws CorruptIndexException,
                                   IOException

  Expert: returns a read/write or read only IndexReader reading the index in the given Directory, using a specific commit and with a custom `IndexDeletionPolicy`.

  Parameters:
    `commit` - the specific `IndexCommit` to open; see `listCommits(org.apache.lucene.store.Directory)` to list all commits in a directory
    `deletionPolicy` - a custom deletion policy (only used if you use this reader to perform deletes or to set norms); see `IndexWriter` for details.
    `readOnly` - true if no changes (deletions, norms) will be made with this IndexReader
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### reopen

    public IndexReader reopen()
                       throws CorruptIndexException,
                              IOException

  Refreshes an IndexReader if the index has changed since this instance was (re)opened.

  Opening an IndexReader is an expensive operation. This method can be used to refresh an existing IndexReader to reduce these costs. This method tries to only load segments that have changed or were created after the IndexReader was (re)opened.

  If the index has not changed since this instance was (re)opened, then this call is a NOOP and returns this instance. Otherwise, a new instance is returned. The old instance is not closed and remains usable.
  Note: The re-opened reader instance and the old instance might share the same resources. For this reason no index modification operations (e. g. `deleteDocument(int)`, `setNorm(int, String, byte)`) should be performed using one of the readers until the old reader instance is closed. Otherwise, the behavior of the readers is undefined.

  You can determine whether a reader was actually reopened by comparing the old instance with the instance returned by this method:

       IndexReader reader = ...
       ...
       IndexReader new = r.reopen();
       if (new != reader) {
         ...     // reader was reopened
         reader.close();
       }
       reader = new;
       ...

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### directory

    public Directory directory()

  Returns the directory associated with this index. The Default implementation returns the directory specified by subclasses when delegating to the IndexReader(Directory) constructor, or throws an UnsupportedOperationException if one was not specified.

  Throws:
    `UnsupportedOperationException` - if no directory

### lastModified

    public static long lastModified(String directory)
                             throws CorruptIndexException,
                                    IOException

  Returns the time the index in the named directory was last modified. Do not use this to check whether the reader is still up-to-date, use `isCurrent()` instead.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### lastModified

    public static long lastModified(File fileDirectory)
                             throws CorruptIndexException,
                                    IOException

  Returns the time the index in the named directory was last modified. Do not use this to check whether the reader is still up-to-date, use `isCurrent()` instead.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### lastModified

    public static long lastModified(Directory directory2)
                             throws CorruptIndexException,
                                    IOException

  Returns the time the index in the named directory was last modified. Do not use this to check whether the reader is still up-to-date, use `isCurrent()` instead.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### getCurrentVersion

    public static long getCurrentVersion(String directory)
                                  throws CorruptIndexException,
                                         IOException

  Reads version number from segments files. The version number is initialized with a timestamp and then increased by one for each change of the index.

  Parameters:
    `directory` - where the index resides.
  Returns:
    version number.
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### getCurrentVersion

    public static long getCurrentVersion(File directory)
                                  throws CorruptIndexException,
                                         IOException

  Reads version number from segments files. The version number is initialized with a timestamp and then increased by one for each change of the index.

  Parameters:
    `directory` - where the index resides.
  Returns:
    version number.
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### getCurrentVersion

    public static long getCurrentVersion(Directory directory)
                                  throws CorruptIndexException,
                                         IOException

  Reads version number from segments files. The version number is initialized with a timestamp and then increased by one for each change of the index.

  Parameters:
    `directory` - where the index resides.
  Returns:
    version number.
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### getVersion

    public long getVersion()

  Version number when this IndexReader was opened. Not implemented in the IndexReader base class.

  Throws:
    `UnsupportedOperationException` - unless overridden in subclass

### setTermInfosIndexDivisor

    public void setTermInfosIndexDivisor(int indexDivisor)
                                  throws IllegalStateException

  For IndexReader implementations that use TermInfosReader to read terms, this sets the indexDivisor to subsample the number of indexed terms loaded into memory. This has the same effect as `IndexWriter.setTermIndexInterval(int)` except that setting must be done at indexing time while this setting can be set per reader. When set to N, then one in every N*termIndexInterval terms in the index is loaded into memory. By setting this to a value > 1 you can reduce memory usage, at the expense of higher latency when loading a TermInfo. The default value is 1.

  NOTE: you must call this before the term index is loaded. If the index is already loaded, an IllegalStateException is thrown.

  Throws:
    `IllegalStateException` - if the term index has already been loaded into memory

### getTermInfosIndexDivisor

    public int getTermInfosIndexDivisor()

  For IndexReader implementations that use TermInfosReader to read terms, this returns the current indexDivisor.

  See Also:
    `setTermInfosIndexDivisor(int)`

### isCurrent

    public boolean isCurrent()
                      throws CorruptIndexException,
                             IOException

  Check whether this IndexReader is still using the current (i.e., most recently committed) version of the index. If a writer has committed any changes to the index since this reader was opened, this will return `false`, in which case you must open a new IndexReader in order to see the changes. See the description of the `autoCommit` flag which controls when the `IndexWriter` actually commits changes to the index.

  Not implemented in the IndexReader base class.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error
    `UnsupportedOperationException` - unless overridden in subclass

### isOptimized

    public boolean isOptimized()

  Checks is the index is optimized (if it has a single segment and no deletions). Not implemented in the IndexReader base class.

  Returns:
    `true` if the index is optimized; `false` otherwise
  Throws:
    `UnsupportedOperationException` - unless overridden in subclass

### getTermFreqVectors

    public abstract TermFreqVector[] getTermFreqVectors(int docNumber)
                                                 throws IOException

  Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector contains terms and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null. The term vectors that are returned my either be of type TermFreqVector or of type TermPositionsVector if positions or offsets have been stored.

  Parameters:
    `docNumber` - document for which term frequency vectors are returned
  Returns:
    array of term frequency vectors. May be null if no term vectors have been stored for the specified document.
  Throws:
    `IOException` - if index cannot be accessed
  See Also:
    `Field.TermVector`

### getTermFreqVector

    public abstract TermFreqVector getTermFreqVector(int docNumber,
                                                     String field)
                                              throws IOException

  Return a term frequency vector for the specified document and field. The returned vector contains terms and frequencies for the terms in the specified field of this document, if the field had the storeTermVector flag set. If termvectors had been stored with positions or offsets, a TermPositionsVector is returned.

  Parameters:
    `docNumber` - document for which the term frequency vector is returned
    `field` - field for which the term frequency vector is returned.
  Returns:
    term frequency vector May be null if field does not exist in the specified document or term vector was not stored.
  Throws:
    `IOException` - if index cannot be accessed
  See Also:
    `Field.TermVector`

### getTermFreqVector

    public abstract void getTermFreqVector(int docNumber,
                                           String field,
                                           TermVectorMapper mapper)
                                    throws IOException

  Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.

  Parameters:
    `docNumber` - The number of the document to load the vector for
    `field` - The name of the field to load
    `mapper` - The `TermVectorMapper` to process the vector. Must not be null
  Throws:
    `IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

### getTermFreqVector

    public abstract void getTermFreqVector(int docNumber,
                                           TermVectorMapper mapper)
                                    throws IOException

  Map all the term vectors for all fields in a Document

  Parameters:
    `docNumber` - The number of the document to load the vector for
    `mapper` - The `TermVectorMapper` to process the vector. Must not be null
  Throws:
    `IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

### indexExists

    public static boolean indexExists(String directory)

  Returns `true` if an index exists at the specified directory. If the directory does not exist or if there is no index in it. `false` is returned.

  Parameters:
    `directory` - the directory to check for an index
  Returns:
    `true` if an index exists; `false` otherwise

### indexExists

    public static boolean indexExists(File directory)

  Returns `true` if an index exists at the specified directory. If the directory does not exist or if there is no index in it.

  Parameters:
    `directory` - the directory to check for an index
  Returns:
    `true` if an index exists; `false` otherwise

### indexExists

    public static boolean indexExists(Directory directory)
                               throws IOException

  Returns `true` if an index exists at the specified directory. If the directory does not exist or if there is no index in it.

  Parameters:
    `directory` - the directory to check for an index
  Returns:
    `true` if an index exists; `false` otherwise
  Throws:
    `IOException` - if there is a problem with accessing the index

### numDocs

    public abstract int numDocs()

  Returns the number of documents in this index.

### maxDoc

    public abstract int maxDoc()

  Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.

### numDeletedDocs

    public int numDeletedDocs()

  Returns the number of deleted documents.

### document

    public Document document(int n)
                      throws CorruptIndexException,
                             IOException

  Returns the stored fields of the `n`th `Document` in this index.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### document

    public abstract Document document(int n,
                                      FieldSelector fieldSelector)
                               throws CorruptIndexException,
                                      IOException

  Get the `Document` at the `n`th position. The `FieldSelector` may be used to determine what `Field`s to load and how they should be loaded. NOTE: If this Reader (more specifically, the underlying `FieldsReader`) is closed before the lazy `Field` is loaded an exception may be thrown. If you want the value of a lazy `Field` to be available after closing you must explicitly load it or fetch the Document again with a new loader.

  Parameters:
    `n` - Get the document at the `n`th position
    `fieldSelector` - The `FieldSelector` to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.
  Returns:
    The stored fields of the `Document` at the nth position
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error
  See Also:
    `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

### isDeleted

    public abstract boolean isDeleted(int n)

  Returns true if document n has been deleted

### hasDeletions

    public abstract boolean hasDeletions()

  Returns true if any documents have been deleted

### hasNorms

    public boolean hasNorms(String field)
                     throws IOException

  Returns true if there are norms stored for this field.

  Throws:
    `IOException`

### norms

    public abstract byte[] norms(String field)
                          throws IOException

  Returns the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.

  Throws:
    `IOException`
  See Also:
    `AbstractField.setBoost(float)`

### norms

    public abstract void norms(String field,
                               byte[] bytes,
                               int offset)
                        throws IOException

  Reads the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.

  Throws:
    `IOException`
  See Also:
    `AbstractField.setBoost(float)`

### setNorm

    public void setNorm(int doc,
                        String field,
                        byte value)
                 throws StaleReaderException,
                        CorruptIndexException,
                        LockObtainFailedException,
                        IOException

  Expert: Resets the normalization factor for the named field of the named document. The norm represents the product of the field's `boost` and its `length normalization`. Thus, to preserve the length normalization values when resetting this, one should base the new value upon the old.

  Throws:
    `StaleReaderException` - if the index has changed since this reader was opened
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if there is a low-level IO error
  See Also:
    `norms(String)`, `Similarity.decodeNorm(byte)`

### doSetNorm

    protected abstract void doSetNorm(int doc,
                                      String field,
                                      byte value)
                               throws CorruptIndexException,
                                      IOException

  Implements setNorm in subclass.

  Throws:
    `CorruptIndexException`
    `IOException`

### setNorm

    public void setNorm(int doc,
                        String field,
                        float value)
                 throws StaleReaderException,
                        CorruptIndexException,
                        LockObtainFailedException,
                        IOException

  Expert: Resets the normalization factor for the named field of the named document.

  Throws:
    `StaleReaderException` - if the index has changed since this reader was opened
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if there is a low-level IO error
  See Also:
    `norms(String)`, `Similarity.decodeNorm(byte)`

### terms

    public abstract TermEnum terms()
                            throws IOException

  Returns an enumeration of all the terms in the index. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration. Note that after calling terms(), `TermEnum.next()` must be called on the resulting enumeration before calling other methods such as `TermEnum.term()`.

  Throws:
    `IOException` - if there is a low-level IO error

### terms

    public abstract TermEnum terms(Term t)
                            throws IOException

  Returns an enumeration of all terms starting at a given term. If the given term does not exist, the enumeration is positioned at the first term greater than the supplied term. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration.

  Throws:
    `IOException` - if there is a low-level IO error

### docFreq

    public abstract int docFreq(Term t)
                         throws IOException

  Returns the number of documents containing the term `t`.

  Throws:
    `IOException` - if there is a low-level IO error

### termDocs

    public TermDocs termDocs(Term term)
                      throws IOException

  Returns an enumeration of all the documents which contain `term`. For each document, the document number, the frequency of the term in that document is also provided, for use in search scoring. Thus, this method implements the mapping:

  Term => <docNum, freq>*

  The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration.

  Throws:
    `IOException` - if there is a low-level IO error

### termDocs

    public abstract TermDocs termDocs()
                               throws IOException

  Returns an unpositioned `TermDocs` enumerator.

  Throws:
    `IOException` - if there is a low-level IO error

### termPositions

    public TermPositions termPositions(Term term)
                                throws IOException

  Returns an enumeration of all the documents which contain `term`. For each document, in addition to the document number and frequency of the term in that document, a list of all of the ordinal positions of the term in the document is available. Thus, this method implements the mapping:

  Term => <docNum, freq, <pos1, pos2, ... posfreq-1> >*

  This positional information facilitates phrase and proximity searching.

  The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration.

  Throws:
    `IOException` - if there is a low-level IO error

### termPositions

    public abstract TermPositions termPositions()
                                         throws IOException

  Returns an unpositioned `TermPositions` enumerator.

  Throws:
    `IOException` - if there is a low-level IO error

### deleteDocument

    public void deleteDocument(int docNum)
                        throws StaleReaderException,
                               CorruptIndexException,
                               LockObtainFailedException,
                               IOException

  Deletes the document numbered `docNum`. Once a document is deleted it will not appear in TermDocs or TermPostitions enumerations. Attempts to read its field with the `document(int)` method will result in an error. The presence of this document may still be reflected in the `docFreq(org.apache.lucene.index.Term)` statistic, though this will be corrected eventually as the index is further modified.

  Throws:
    `StaleReaderException` - if the index has changed since this reader was opened
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if there is a low-level IO error

### doDelete

    protected abstract void doDelete(int docNum)
                              throws CorruptIndexException,
                                     IOException

  Implements deletion of the document numbered `docNum`. Applications should call `deleteDocument(int)` or `deleteDocuments(Term)`.

  Throws:
    `CorruptIndexException`
    `IOException`

### deleteDocuments

    public int deleteDocuments(Term term)
                        throws StaleReaderException,
                               CorruptIndexException,
                               LockObtainFailedException,
                               IOException

  Deletes all documents that have a given `term` indexed. This is useful if one uses a document field to hold a unique ID string for the document. Then to delete such a document, one merely constructs a term with the appropriate field and the unique ID string as its text and passes it to this method. See `deleteDocument(int)` for information about when this deletion will become effective.

  Returns:
    the number of documents deleted
  Throws:
    `StaleReaderException` - if the index has changed since this reader was opened
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if there is a low-level IO error

### undeleteAll

    public void undeleteAll()
                     throws StaleReaderException,
                            CorruptIndexException,
                            LockObtainFailedException,
                            IOException

  Undeletes all documents currently marked as deleted in this index.

  Throws:
    `StaleReaderException` - if the index has changed since this reader was opened
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### doUndeleteAll

    protected abstract void doUndeleteAll()
                                   throws CorruptIndexException,
                                          IOException

  Implements actual undeleteAll() in subclass.

  Throws:
    `CorruptIndexException`
    `IOException`

### acquireWriteLock

    protected void acquireWriteLock()
                             throws IOException

  Does nothing by default. Subclasses that require a write lock for index modifications must implement this method.

  Throws:
    `IOException`

### flush

    public final void flush()
                     throws IOException

  Throws:
    `IOException`

### commit

    protected final void commit()
                         throws IOException

  Commit changes resulting from delete, undeleteAll, or setNorm operations If an exception is hit, then either no changes or all changes will have been committed to the index (transactional semantics).

  Throws:
    `IOException` - if there is a low-level IO error

### doCommit

    protected abstract void doCommit()
                              throws IOException

  Implements commit.

  Throws:
    `IOException`

### close

    public final void close()
                     throws IOException

  Closes files associated with this index. Also saves any new deletions to disk. No other methods should be called after this has been called.

  Throws:
    `IOException` - if there is a low-level IO error

### doClose

    protected abstract void doClose()
                             throws IOException

  Implements close.

  Throws:
    `IOException`

### getFieldNames

    public abstract Collection getFieldNames(IndexReader.FieldOption fldOption)

  Get a list of unique field names that exist in this index and have the specified field option information.

  Parameters:
    `fldOption` - specifies which field option should be available for the returned fields
  Returns:
    Collection of Strings indicating the names of the fields.
  See Also:
    `IndexReader.FieldOption`

### isLocked

    public static boolean isLocked(Directory directory)
                            throws IOException

  Deprecated. Please use `IndexWriter.isLocked(Directory)` instead

  Returns `true` iff the index in the named directory is currently locked.

  Parameters:
    `directory` - the directory to check for a lock
  Throws:
    `IOException` - if there is a low-level IO error

### isLocked

    public static boolean isLocked(String directory)
                            throws IOException

  Deprecated. Please use `IndexWriter.isLocked(String)` instead

  Returns `true` iff the index in the named directory is currently locked.

  Parameters:
    `directory` - the directory to check for a lock
  Throws:
    `IOException` - if there is a low-level IO error

### unlock

    public static void unlock(Directory directory)
                       throws IOException

  Deprecated. Please use `IndexWriter.unlock(Directory)` instead

  Forcibly unlocks the index in the named directory.

  Caution: this should only be used by failure recovery code, when it is known that no other process nor thread is in fact currently accessing this index.

  Throws:
    `IOException`

### getIndexCommit

    public IndexCommit getIndexCommit()
                               throws IOException

  Expert: return the IndexCommit that this reader has opened. This method is only implemented by those readers that correspond to a Directory with its own segments_N file.

  WARNING: this API is new and experimental and may suddenly change.

  Throws:
    `IOException`

### main

    public static void main(String[] args)

  Prints the filename and size of each file within a given compound file. Add the -extract flag to extract files to the current working directory. In order to make the extracted version of the index work, you have to copy the segments file from the compound index into the directory where the extracted files are stored.

  Parameters:
    `args` - Usage: org.apache.lucene.index.IndexReader [-extract] <cfsfile>

### listCommits

    public static Collection listCommits(Directory dir)
                                  throws IOException

  Returns all commit points that exist in the Directory. Normally, because the default is `KeepOnlyLastCommitDeletionPolicy`, there would be only one commit point. But if you're using a custom `IndexDeletionPolicy` then there could be many commits. Once you have a given commit, you can open a reader on it by calling `open(IndexCommit)` There must be at least one commit in the Directory, else this method throws `IOException`. Note that if a commit is in progress while this method is running, that commit may or may not be returned array.

  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2009 Apache Software Foundation. All Rights Reserved.